/*
 * SliceableEdit.java
 *
 * Created on July 14, 2006, 8:18 PM
 *
 * @author Paul Kratt
 * @desc An editing window with some properties for "sliceable" skin items.
 *
 * Note: This code was released as open source on January 6th 2007.
 * There is no license behind it. The only restrictions I ask are that it may
 * not be sold and that some form of credit towards me remains if you use it.
 */

package trillianskinviewer;

import javax.swing.JOptionPane;

public class SliceableEdit extends javax.swing.JPanel {
    SliceableItem myitm;
    
    /** Creates new form SliceableEdit */
    public SliceableEdit(SliceableItem itm) {
        initComponents();
        myitm = itm;
        loadValues();
    }
    
    /** Load the values from SliceableItem **/
    public void loadValues(){
        txtLeft.setText(""+myitm.getLeft());
        txtRight.setText(""+myitm.getRight());
        txtTop.setText(""+myitm.getTop());
        txtBottom.setText(""+myitm.getBottom());
        txtSliceLeft.setText(""+myitm.getSliceleft());
        txtSliceRight.setText(""+myitm.getSliceright());
        txtSliceTop.setText(""+myitm.getSlicetop());
        txtSliceBottom.setText(""+myitm.getSlicebottom());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        txtLeft = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtRight = new javax.swing.JTextField();
        txtTop = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtBottom = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        txtSliceLeft = new javax.swing.JTextField();
        txtSliceRight = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        txtSliceTop = new javax.swing.JTextField();
        txtSliceBottom = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        btnSetMax = new javax.swing.JButton();
        btnApply = new javax.swing.JButton();

        txtLeft.setText("0");

        jLabel1.setText("Left:");

        jLabel2.setText("Right:");

        txtRight.setText("0");

        txtTop.setText("50");

        jLabel3.setText("Top:");

        jLabel4.setText("Bottom:");

        txtBottom.setText("50");

        jLabel5.setText("Slice Location:");

        jLabel6.setText("Left:");

        txtSliceLeft.setText("1");

        txtSliceRight.setText("1");

        jLabel7.setText("Right:");

        jLabel8.setText("Top:");

        txtSliceTop.setText("49");

        txtSliceBottom.setText("49");

        jLabel9.setText("Bottom");

        btnSetMax.setText("Maximums");
        btnSetMax.setToolTipText("Grab the largest possible values for this image");
        btnSetMax.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSetMaxActionPerformed(evt);
            }
        });

        btnApply.setText("Apply");
        btnApply.setToolTipText("Apply changes and update the preview.");
        btnApply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnApplyActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel9)
                            .add(jLabel8)
                            .add(jLabel7)
                            .add(jLabel6))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(txtSliceLeft, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 236, Short.MAX_VALUE)
                            .add(layout.createSequentialGroup()
                                .add(btnSetMax)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 92, Short.MAX_VALUE)
                                .add(btnApply))
                            .add(txtSliceRight, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 236, Short.MAX_VALUE)
                            .add(txtSliceTop, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 236, Short.MAX_VALUE)
                            .add(txtSliceBottom, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 236, Short.MAX_VALUE)))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel4)
                            .add(jLabel3)
                            .add(jLabel2)
                            .add(jLabel1))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtRight, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 232, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, txtTop, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 232, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(txtBottom, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 232, Short.MAX_VALUE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                            .add(txtLeft, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 232, Short.MAX_VALUE)))
                    .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 274, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(txtLeft, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(txtRight, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(txtTop, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(txtBottom, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel5)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel6)
                    .add(txtSliceLeft, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(txtSliceRight, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel7))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(txtSliceTop, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel8))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel9)
                    .add(txtSliceBottom, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnApply)
                    .add(btnSetMax))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnSetMaxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSetMaxActionPerformed
        txtTop.setText("0");
        txtLeft.setText("0");
        txtSliceTop.setText("1");
        txtSliceLeft.setText("1");
        if(myitm.knowsSize()){
            txtBottom.setText(""+myitm.getHeight());
            txtSliceBottom.setText(""+(myitm.getHeight()-1));
            txtRight.setText(""+myitm.getWidth());
            txtSliceRight.setText(""+(myitm.getWidth()-1));
        }
        else{
            //Item doesn't know how big it is. :-(
            txtBottom.setText("5");
            txtSliceBottom.setText("4");
            txtRight.setText("5");
            txtSliceRight.setText("4");
        }
    }//GEN-LAST:event_btnSetMaxActionPerformed

    private void btnApplyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnApplyActionPerformed
        JOptionPane msgbox = new JOptionPane();
        try {
            myitm.setTop(Integer.parseInt(txtTop.getText()));
            myitm.setBottom(Integer.parseInt(txtBottom.getText()));
            myitm.setLeft(Integer.parseInt(txtLeft.getText()));
            myitm.setRight(Integer.parseInt(txtRight.getText()));
            myitm.setSlicetop(Integer.parseInt(txtSliceTop.getText()));
            myitm.setSlicebottom(Integer.parseInt(txtSliceBottom.getText()));
            myitm.setSliceleft(Integer.parseInt(txtSliceLeft.getText()));
            myitm.setSliceright(Integer.parseInt(txtSliceRight.getText()));
            myitm.boundsCheck();
            loadValues();
            myitm.updateSaveData();
            myitm.refreshViewer();
        } catch (NumberFormatException ex) {
            msgbox.showMessageDialog(this,"You must enter whole numbers!");
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btnApplyActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnApply;
    private javax.swing.JButton btnSetMax;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JTextField txtBottom;
    private javax.swing.JTextField txtLeft;
    private javax.swing.JTextField txtRight;
    private javax.swing.JTextField txtSliceBottom;
    private javax.swing.JTextField txtSliceLeft;
    private javax.swing.JTextField txtSliceRight;
    private javax.swing.JTextField txtSliceTop;
    private javax.swing.JTextField txtTop;
    // End of variables declaration//GEN-END:variables
    
}
